"""
    Feiertage API

    Deutsche Feiertage per JSON-Webservice (API)   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: kontakt@bund.dev
    Generated by: https://openapi-generator.tech
"""

import re  # noqa: F401
import sys  # noqa: F401

from deutschland.feiertage.api_client import ApiClient
from deutschland.feiertage.api_client import Endpoint as _Endpoint
from deutschland.feiertage.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types,
)


class DefaultApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.get_feiertage_endpoint = _Endpoint(
            settings={
                "response_type": (
                    {
                        str: (
                            bool,
                            date,
                            datetime,
                            dict,
                            float,
                            int,
                            list,
                            str,
                            none_type,
                        )
                    },
                ),
                "auth": [],
                "endpoint_path": "/",
                "operation_id": "get_feiertage",
                "http_method": "GET",
                "servers": None,
            },
            params_map={
                "all": [
                    "jahr",
                    "nur_land",
                    "nur_daten",
                ],
                "required": [],
                "nullable": [],
                "enum": [
                    "nur_land",
                ],
                "validation": [],
            },
            root_map={
                "validations": {},
                "allowed_values": {
                    ("nur_land",): {
                        "NATIONAL": "NATIONAL",
                        "BW": "BW",
                        "BY": "BY",
                        "BE": "BE",
                        "BB": "BB",
                        "HB": "HB",
                        "HH": "HH",
                        "HE": "HE",
                        "MV": "MV",
                        "NI": "NI",
                        "NW": "NW",
                        "RP": "RP",
                        "SL": "SL",
                        "SN": "SN",
                        "ST": "ST",
                        "SH": "SH",
                        "TH": "TH",
                    },
                },
                "openapi_types": {
                    "jahr": (str,),
                    "nur_land": (str,),
                    "nur_daten": (int,),
                },
                "attribute_map": {
                    "jahr": "jahr",
                    "nur_land": "nur_land",
                    "nur_daten": "nur_daten",
                },
                "location_map": {
                    "jahr": "query",
                    "nur_land": "query",
                    "nur_daten": "query",
                },
                "collection_format_map": {},
            },
            headers_map={
                "accept": ["application/json"],
                "content_type": [],
            },
            api_client=api_client,
        )

    def get_feiertage(self, **kwargs):
        """Get Feiertage  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_feiertage(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            jahr (str): Welches Jahr?. [optional]
            nur_land (str): Welches Bundesland?. [optional]
            nur_daten (int): Nur Daten oder auch Hinweise?. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            {str: (bool, date, datetime, dict, float, int, list, str, none_type)}
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs["async_req"] = kwargs.get("async_req", False)
        kwargs["_return_http_data_only"] = kwargs.get("_return_http_data_only", True)
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")
        kwargs["_request_auths"] = kwargs.get("_request_auths", None)
        return self.get_feiertage_endpoint.call_with_http_info(**kwargs)
